
/* ----------------------------------------------------------------------------------
	ZLIC - }CRRA^CtkCu
	Copyright(C) 2010 K_Yaguchi.
	All rights reserved.
---------------------------------------------------------------------------------- */

#if !defined(_H_ZLIC_)
#define _H_ZLIC_



typedef unsigned char    uint8;          /* char^8bitł͂ȂꍇA8biť^ɒuĂ */
typedef unsigned long    uint32;         /* Œ9bitȏ̌^̂ */
typedef unsigned int     uint;           /* intȏꍇbitȂꍇlong,short,charȂǍDȂ̂ɕςĂOKł */

#define WND_REF_BIT      4               /* Qƈʒu̕\ɕKvȃrbg 4=16 */
#define WND_LEN_BIT      3               /* ̕\ɕKvȃrbg 3=8 */

/*
	̒l傫Ǝ኱k͗ǂȂ܂܂傫ȂłB
	WND_LEN_BIT  WND_REF_BIT KĂB

	̐ݒ܂łȂ瓮͂
	#define WND_REF_BIT      8    256
	#define WND_LEN_BIT      7    128
*/





/* ---------------------------------------------------
	牺͕ύXȂĂǂ͂
--------------------------------------------------- */

/* tOl` */
#if !defined(TRUE)
#define TRUE      1
#endif
#if !defined(FALSE)
#define FALSE     0
#endif

/* ^` */
#if !defined(BOOL)
typedef char             BOOL;
#endif

#define ZLIC_SUCCESS(n)           ( (n)==0 )                              /*  */
#define ZLIC_SRC(n)               ( (n)==1 )                              /* src؂ւ */
#define ZLIC_DEST(n)              ( (n)==2 )                              /* dest؂ւ */

#define UINT8_BIT                 ( sizeof(uint8)*8 )                     /* uint8̃rbg */

#define MATCH_BITLEN              ( 1+WND_REF_BIT+WND_LEN_BIT )           /* vrbg */
#define NOMATCH_BITLEN            ( 1+UINT8_BIT )                         /* svrbg */

#define WND_REF_SIZE              ( 1<<WND_REF_BIT )                      /* QƑ̑傫 */
#define WND_VALUE_SIZE            ( 1<<WND_LEN_BIT )                      /* ̑傫 */
#define WND_SIZE                  ( WND_REF_SIZE+WND_VALUE_SIZE )         /* TCY */

/* }N */

/* v 8bit ( LLLR RRR1 ) */
#define SETBIT_MATCH(ref,len)     ( (uint32)( (((uint32)(len)&(WND_VALUE_SIZE-1))<<(WND_REF_BIT+1)) | (((uint32)(ref)&(WND_REF_SIZE-1))<<1) | 0x01 ) )
/* sv 9bit ( xxxN NNNN NNN0 ) */
#define SETBIT_NOMATCH(n)         ( (uint32)( ((uint32)(n)<<1) & (~0x01) ) )




/* 51: \ */
typedef struct _ZLIC_DATA {
	uint8   pWnd[WND_SIZE];        /* 24: XCh */
	uint8   nWndStart;             /*  1: Jnʒu */
	int     nWndEnd;               /*  4: Iʒu+1 */
	uint32  nEncBit;               /*  4: rbg */
	uint8   nEncBitLen;            /*  1: rbg */
	int     nSkip;                 /*  4: ΂oCg */
	uint    nWritten;              /*  4: 񂾃oCg */
	uint    nSrcPos;               /*  4: src̈ʒu */
	uint    nDestPos;              /*  4: desẗʒu */
	uint8   nBitPos;               /*  1: rbg̈ʒu */
	uint a;
} ZLIC_DATA;





/* vg^Cv */
void zlic_setup(ZLIC_DATA* zd);
int zlic_compress(ZLIC_DATA* zd, const uint8* src, uint src_size, uint8* dest, uint dest_size, uint* written);
int zlic_uncompress(ZLIC_DATA* zd, const uint8* src, uint src_size, uint8* dest, uint dest_size, uint* written);


#endif /* _H_ZLIC_ */


