
/* ----------------------------------------------------------------------------------
	ZLIC - }CRRA^CtkCu

	Windowsp TvvO

	Copyright(C) 2010 K_Yaguchi.
	All rights reserved.
---------------------------------------------------------------------------------- */

#include <stdio.h>
#include "zlic.h"




/* ----------------------------------------------------------------------------------
	ygz
	R}hvvg
	zlic.exe t@C[Enter]

	sƁA
	t@C.enc  kt@C
	t@C.txt  kecsv
	t@C.dec  𓀂t@C
	̂Rł܂B
	csvt@CC\[Xֈkf[^̓eoɎg܂Bconst unsigned char data[]={...}; ...̕B
	.dec͌t@CƑSeɂȂ܂̂ŁAt@CƔrĐɖ߂Ă邩`FbNł܂B
---------------------------------------------------------------------------------- */
int main(int argc, char* argp[])
{
	ZLIC_DATA zd={0};
	char szEncFile[260]="";
	char szCsvFile[260]="";
	char szDecFile[260]="";
	FILE* in;
	FILE* out;
	uint8 src;
	uint8 dest;
	uint src_size=0;
	uint dest_size=0;
	uint written=0;
	int ret;

	if( argc <= 1 )
	{
		printf("zlic.exe t@C[Enter]\n");
		return 0;
	}

	sprintf(szEncFile, "%s.enc", argp[1]);
	sprintf(szCsvFile, "%s.txt", argp[1]);
	sprintf(szDecFile, "%s.dec", argp[1]);

	/* -----------------------------------------
		k

		src1oCgǂݏo
		dest1oCgo
	----------------------------------------- */
	printf("k: ");

	/* ̓t@CJ */
	in = fopen(argp[1], "rb");
	if( !in )  { printf("̓t@CJ܂\n"); return 0; }
	/* kt@CJ */
	out = fopen(szEncFile, "wb");
	if( !out ) { printf("o̓t@CJ܂\n"); fclose(in); return 0; }

	src_size  = 0;
	dest_size = 0;
	written   = 0;
	ret = 1;
	zlic_setup( &zd ); /* \̏ */
	for(;;)
	{
		if( ZLIC_SRC(ret) )
		{
			/* \[X */
			src_size = fread(&src, 1, sizeof(src), in);
		}
		else if( ZLIC_DEST(ret) )
		{
			/* obt@ */
			fwrite(&dest, 1, sizeof(dest), out);
		}
		else
		{
			/*  ZLIC_SUCCESS(ret) */
			fwrite(&dest, 1, written, out); /* Ō̃f[^o */
			break;
		}
		/* k */
		written = 0;
		ret = zlic_compress(&zd, &src, src_size, &dest, sizeof(dest), &written);
		dest_size += written;
	}
	printf(" %u byte(%.1fKB)\n", dest_size, (double)dest_size/1024.0);
	fclose( in );
	fclose( out );

	/* -----------------------------------------
		csv֏o
	----------------------------------------- */
	printf("CSV: ");

	in = fopen(szEncFile, "rb");
	if( !in )  { printf("kt@CJ܂\n"); return 0; }
	out = fopen(szCsvFile, "wt");
	if( !out ) { printf("o̓t@CJ܂\n"); fclose(in); return 0; }

	src_size = 0;
	fprintf(out, "/* %ubyte(%.1fKB) */\n", dest_size, (double)dest_size/1024.0);
	while( fread(&src,1,sizeof(src),in)>0 )
	{
		fprintf(out, "0x%02x,", src);
		if( (src_size % 16)==15 ) fputs("\n", out);
		src_size++;
	}
	printf("\n");
	fclose( in );
	fclose( out );

	/* -----------------------------------------
		

		src1oCgǂݏo
		dest1oCgo
	----------------------------------------- */
	printf("𓀒: ");

	/* ̓t@CJ */
	in = fopen(szEncFile, "rb");
	if( !in )  { printf("kt@CJ܂\n"); return 0; }
	/* 𓀌t@CJ */
	out = fopen(szDecFile, "wb");
	if( !out ) { printf("o̓t@CJ܂\n"); fclose( in ); return 0; }

	src_size  = 0;
	dest_size = 0;
	written   = 0;
	ret = 1;
	zlic_setup( &zd ); /* \̏ */
	for(;;)
	{
		if( ZLIC_SRC(ret) )
		{
			/* \[X */
			src_size = fread(&src, 1, sizeof(src), in);
		}
		else if( ZLIC_DEST(ret) )
		{
			/* obt@ */
			fwrite(&dest, 1, sizeof(dest), out);
		}
		else
		{
			/*  ZLIC_SUCCESS(ret) */
			fwrite(&dest, 1, written, out); /* Ōo */
			break;
		}
		/*  */
		written = 0;
		ret = zlic_uncompress(&zd, &src, src_size, &dest, sizeof(dest), &written);
		dest_size += written;
	}
	printf(" %u byte(%.1fKB)\n", dest_size, (double)dest_size/1024.0);
	fclose( in );
	fclose( out );

	return 0;
}

